<!-- YOU ARE FREE TO USE OR MODIFY THIS CODE ANYWAY YOU LIKE, BUT PLEASE KEEP THE LINK AT THE BOTTOM OF THE PAGE -->
<!-- OR PUT A LINK THAT IS OBVIOUS IN HERE SO THAT OTHERS MAY ENJOY THIS OPEN SOURCE PROGRAM TOO -->
<!-- http://daevid.com/examples/dhcp/ for the latest version, (c)2003-2009 Daevid Vincent, All rights reserved. -->
<?php
	// written by Daevid Vincent (http://daevid.com) daevid@daevid.com
	
	// you may set this to the LAN segments you wish to monitor (use CIDR notation),
	// or leave it blank to use the IP address the script will determine on its own.
	$LANS = array('192.168.1.0/24');

	$ETH0 = "enp6s0"; //was "ens2";

	$NMAP = "/usr/bin/nmap";
	//you MUST add this line to /etc/sudoers 
	//www-data ALL= NOPASSWD: /usr/bin/nmap,/usr/sbin/arp

	$_GET['test'] = @($_GET['test']) ?: '';
	$_GET['refresh'] = @($_GET['refresh']) ?: '600';
	
	if (count($LANS) < 1) $LANS = array($_SERVER['HTTP_HOST']);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title>DHCP Map</title>
	<STYLE>     
	 TD, TH, BODY, BUTTON, INPUT 
	 {
	     font-family: 	Trebuchet MS, Verdana, Arial, Helvetica, sans-serif;
	     font-variant: 	normal;
	     font-style: 	normal;
         font-size:     8pt;
         color:         Black;
     }
	
     a 			{ cursor: pointer; }
     a:link 	{text-decoration: none; 	color: #6D15C0}
     a:visited 	{text-decoration: none; 	color: #6D15C0}
     a:active 	{text-decoration: italic; 	color: #FF0000}
     a:hover 	{text-decoration: none; 	color: #FF0000}

	.setting {
		background-color:	silver;
		position:			relative;
		top:				18;
		left:				10;
		margin-right:		10;
	}
    </STYLE>
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	var currentRow;
	var oldColor = '';
	function highlightRow(row)
	{
		if (currentRow)	currentRow.bgColor = oldColor;
	
		oldColor = row.bgColor;
		currentRow = row;
		currentRow.bgColor = '#F1F1F1';
	}
	
	function unHighlightRow(row)
	{
		currentRow.bgColor = oldColor;
	}
	//-->
	</SCRIPT>
	<META HTTP-EQUIV="refresh" CONTENT="<?=$_GET['refresh']?>; URL=<?=$_SERVER['PHP_SELF']?>?refresh=<?=$_GET['refresh']?>&test=<?=$_GET['test']?>"> 
	<meta http-equiv="expires" content="Tue, Nov 21 2000 05:00:00 GMT"> 
	<meta http-equiv="cache-control" content="no-cache"><!-- Force Refresh HTTP1.1 --> 
	<meta http-equiv="pragma" content="no-cache"><!-- Force Refresh HTTP1.0 --> 
</head>
<body>
<CENTER>
<P>
<!-- MASTER TABLE --><TABLE border="1" cellpadding="5" cellspacing="0" bgcolor="SILVER" bordercolordark="#FFFFFF" bordercolorlight="#000000"><TR><TD>

<?php
	// this is to enable or disable the ping and nmap tests. turning this to false will radically speed up the page rendering.
	$TEST_CONNECTION = (isset($_GET['test']) && $_GET['test'] == 1);
	
	error_reporting(E_ALL & ~E_NOTICE);
	ini_set('display_errors', true);
	
	require_once("device.class.php");
	
	//read in the "/var/lib/dhcp/dhcpd.leases" file so we can map the windows machine names and lease start/end.
	//include_once("lease_parser.php");
	
	$machine = array();
	$interface = array();
	$tempInterface = array();
	$incomplete_count = 0;
	$complete_count = 0;
	
	//TODO: re-write this with just "sudo nmap -PR -sP -oX nmap.xml -n 192.168.1.0/24" as it has all the devices
	//      and removes the need for arp below too.

	//tries to refresh the arp cache...
	foreach ($LANS as $LAN)
	{
		$COMMAND = "sudo ".$NMAP." -p 80,22,445,135,138,139 -n ".$LAN.' --max-parallelism 100';
		echo "<!-- ".$COMMAND." -->\n";
		exec($COMMAND);
		//TODO: would be great to parse THIS output and use the MAC manufacturer as a roll-over on Interface to help maybe figure out what a device is. Could also be useful to show any open ports found
	}
    //TODO: if port 80 is alive, then set a hyperlink in the table below.	
	//TODO: might want to switch to "ip -o neigh show" at some point instead of the antiquated 'arp'
	$arpn = `/usr/sbin/arp -n | /usr/bin/grep -v "incomplete" | /usr/bin/grep -v "Address" | /usr/bin/sort`; //we use ` ` notation because it dumps all the output into a single variable.
	// note that `arp -v` tries to figure out what a device is (but doesn't show the IP if it finds it's name!)
	$temp = explode("\n", $arpn);
	array_pop($temp); //the last element is empty

	//"arp" and "in" don't show the box we're running it on, so we have to append it manually...
	$local = preg_split("/[\s:]+/",exec("/sbin/ifconfig -a $ETH0 | /bin/grep 'inet '"), -1, PREG_SPLIT_NO_EMPTY);
	$dot_quad_ip_eth0 = $local[1];
	$local = preg_split("/\s+/",exec("/sbin/ifconfig -a $ETH0 | /bin/grep ether"), -1, PREG_SPLIT_NO_EMPTY);
	$MAC_addr_eth0 = $local[1];
	unset($local);
	$temp[] = $dot_quad_ip_eth0.'  ether '.$MAC_addr_eth0." C $ETH0";

	$leases = array();
	$m = 1;
	$incomplete = false;
	for($i = 0; $i < count($temp); $i++)
	{
		$arp = preg_split("/ /",$temp[$i], -1, PREG_SPLIT_NO_EMPTY);
		
		$complete_count++;
		$ip = $arp[0];
		$macaddress = $arp[2];
		$tempInterface[$i] = $arp[4];
		
		$name = @$leases[$ip]['client-hostname'];
		if ($name) $name = str_replace("\"", "", $name);
		
		//we used to use the MAC as a unique key, but turns out VMWARE will show up on the host's mac
		$machine[$m] = new device($ip,$macaddress,$name,$tempInterface[$i], $incomplete, $TEST_CONNECTION);
		$machine[$m]->setLease(@$leases[$ip]['starts'], @$leases[$ip]['ends']);
		$m++;
	}
	unset($temp);

	///////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////
	//find the unique and active interfaces:
	//we could parse "cat /proc/net/dev" as well if we really wanted to know all interfaces, but generally 
	//we would only care about the current ones in use.
	$tempInterface = array_unique($tempInterface);
	foreach ($tempInterface as $key => $value)
	{
		$temp = preg_split("/\s+/",exec("/sbin/ifconfig -a $value | /bin/grep HWaddr"), -1, PREG_SPLIT_NO_EMPTY);
		if (is_array($temp) && count($temp) >= 4)
			$MAC = $temp[4];
		else 
			$MAC = 'unknown MAC';
	
		$temp = preg_split("/[\s:]+/",exec("/sbin/ifconfig -a $value | /bin/grep \"inet addr:\""), -1, PREG_SPLIT_NO_EMPTY);
		if (is_array($temp) && count($temp) >= 2)
			$IP = $temp[2];
		else 
			$IP = 'unknown IP';
		
		$interface[$value] = new interfaceX($IP, $MAC, $value);
	}
	unset($temp);
	unset($tempInterface);

	///////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////
	// read in the dhcp_map.ini file to map MAC addresses to images
	$mapFile = "./dhcp_map.ini";
	$tempMap = '';
	if( $fp = @fopen($mapFile, "r") )
	{
		while( $line = fgets($fp, 1024) )
			if ($line[0] != "#") $tempMap .= $line;  // strip out # comments
	} else echo "ERROR: Can't read ".$mapFile."<BR>";
	fclose ($fp);
	
	$map = explode("\n", $tempMap);	
	//print "<pre>"; print_r($map); print "</pre>";
	//for($i = 0; $i < count($map); $i++)
	foreach($map as $mapi)
	{
		//list($mac, $image, $name) = preg_split("/\s/",$map[$i], -1, PREG_SPLIT_NO_EMPTY);
		preg_match("/(..:..:..:..:..:..)\s+(\w+)\s+(.*)/i", $mapi, $matches);
		//print "<pre>"; var_dump($matches); print "</pre>";
		@list($junk, $mac, $image, $name) = $matches;
		
		foreach($machine as $key => $mobj)
		{
			//if ( array_key_exists($mac, $machine)) $machine[$mac]->setImage($image);
			if (!is_null($mac) && stripos($mobj->getMAC(),$mac) !== false) 
			{
				$mobj->setImage($image);
				if ($name != '') $mobj->setName($name);
				//if ( isset($machine[$mac]) && $name != "" /*&& $machine[$mac]->getName() == ""*/) $machine[$mac]->name = $name;
				unset($mapi);
			}
		}
	}
	unset($tempMap);
	unset($map);

	///////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////

	$numInterfaces = count($interface);
	$numMachines = count($machine);

	function cmp ($a, $b) {
		$tempA = ip2long($a->getIP());
		$tempB = ip2long($b->getIP());
	    if ($tempA == $tempB) return 0;
    	return ($tempA < $tempB) ? -1 : 1;
	}
	uasort($machine, "cmp");
?>
	<!-- MACHINE TABLE -->
		<SPAN CLASS="setting"><B>&nbsp;<IMG SRC="./images/network.gif" WIDTH="32" HEIGHT="32" ALT="Devices" BORDER="0" ALIGN="absmiddle"> &nbsp;<?=$numMachines?> ( <?=$complete_count?> complete / <?=$incomplete_count?> incomplete ) Devices on Network &nbsp; </B></SPAN>
		<TABLE STYLE="border: 2 groove;" CELLPADDING="4" WIDTH="100%"><TR ALIGN="center"><TD><BR>
			<TABLE border="0" cellpadding="0" cellspacing="0" WIDTH="100%">
				<?php if ($numMachines > 0) { ?>
				<TR>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="50" HEIGHT="1"></TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="50" HEIGHT="1"><BR>ping/nmap</TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="100" HEIGHT="1"><BR>IP</TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="100" HEIGHT="1"><BR>MAC</TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="100" HEIGHT="1"><BR>Name</TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="150" HEIGHT="1"><BR>Lease Starts<BR>Lease Ends</TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="100" HEIGHT="1"><BR>Interface</TH>
				</TR>
					<?php 
					$i = 1;
					foreach ($machine as $key => $object)
					{ ?>
					<TR><TD COLSPAN="7" HEIGHT="2"><HR></TD></TR>
					<TR ALIGN="center" VALIGN="middle" onMouseOver='highlightRow(this)' onMouseOut='unHighlightRow(this)'>
						<TD><IMG SRC="./images/<?=$object->getImage()?>_<?php echo (!($object->incomplete)) ? "1" : "0" ?>.gif" BORDER="0" ALT="Device #<?=$i++?>"></TD>
						<TD>
							<?php if ($TEST_CONNECTION) { ?>
							<IMG SRC="./images/light_<?php echo ($object->active_ping) ? "1" : "0" ?>.gif" BORDER="0" ALT="ping">
							<IMG SRC="./images/light_<?php echo ($object->active_nmap) ? "1" : "0" ?>.gif" BORDER="0" ALT="nmap">
							<?php } else { ?>
							<IMG SRC="./images/light_yellow.gif" BORDER="0" ALT="untested">
							<?php } ?>
						</TD>
						<TD><a href="http://<?=$object->getIP()?>" target="_blank"><?=$object->getIP()?></a></TD>
						<TD><?=$object->getMAC()?></TD>
						<TD align="left">&nbsp;&nbsp;&nbsp;<?=$object->getName()?></TD>
						<TD><?=$object->lease_start?><BR><?=$object->lease_end?></TD>
						<TD><IMG SRC="images/<?=$object->getInterface()?>.gif" ALT="<?=$object->getInterface()?>" BORDER="0"></TD>
					</TR>
					<?php 
					} //for loop
				} else {?>
				<TR><TD COLSPAN="7" ALIGN="center"><I>No Devices found on the DHCP network</I></TD></TR>
				<?php
				}
				?>
				<TR><TD COLSPAN="7" ALIGN="center"><HR>Edit the <A HREF="dhcp_map.ini">dhcp_map.ini</A> file to change the icons</TD></TR>
			</TABLE>
		</TD></TR></TABLE>
	<!-- MACHINE TABLE -->



	<!-- INTERFACE TABLE -->
		<SPAN CLASS="setting"><B>&nbsp;<IMG SRC="./images/info.gif" WIDTH="32" HEIGHT="32" ALT="Interfaces" BORDER="0" ALIGN="absmiddle"> &nbsp;<?=$numInterfaces?> active Interfaces on Network &nbsp; </B></SPAN>
		<TABLE STYLE="border: 2 groove;" CELLPADDING="4" WIDTH="100%"><TR ALIGN="center"><TD><BR>
			<TABLE border="0" cellpadding="0" cellspacing="0" WIDTH="100%">
				<TR>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="50" HEIGHT="1"></TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="100" HEIGHT="1"><BR>Interface</TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="100" HEIGHT="1"><BR>IP</TH>
					<TH><IMG SRC="./images/1pixel.gif" WIDTH="100" HEIGHT="1"><BR>MAC</TH>
				</TR>
				<?php 
				foreach ($interface as $key => $object)
				{ ?>
				<TR><TD COLSPAN="6" HEIGHT="2"><HR></TD></TR>
				<TR ALIGN="center" VALIGN="middle" onMouseOver='highlightRow(this)' onMouseOut='unHighlightRow(this)'>
					<TD><IMG SRC="./images/<?=$object->name?>.gif" BORDER="0" ALT="<?=$object->name?>"></TD>
					<TD><?=$object->name?></TD>
					<TD><?=$object->IP?></TD>
					<TD><?=$object->MAC?></TD>
				</TR>
				<?php 
				} //for loop
				?>
			</TABLE>
		</TD></TR></TABLE>
	<!-- INTERFACE TABLE -->
	
			<center>
			<?php if ($_GET['refresh'] == "" ) $_GET['refresh'] = '600'; ?>
			
			<FORM Method="GET" ACTION="<?=$_SERVER['PHP_SELF']?>">
			<SELECT NAME="refresh">
				<OPTION VALUE="60" <?php if ($_GET['refresh'] == '60') echo "SELECTED"; ?>>1 min
				<OPTION VALUE="600" <?php if ($_GET['refresh'] == '300') echo "SELECTED"; ?>>5 min
				<OPTION VALUE="600" <?php if ($_GET['refresh'] == '600') echo "SELECTED"; ?>>10 min
				<OPTION VALUE="3600" <?php if ($_GET['refresh'] == '3600') echo "SELECTED"; ?>>1 hour
				<OPTION VALUE="21600" <?php if ($_GET['refresh'] == '21600') echo "SELECTED"; ?>>6 hours
				<OPTION VALUE="21600" <?php if ($_GET['refresh'] == '43200') echo "SELECTED"; ?>>12 hours
			</SELECT>
			<INPUT TYPE="SUBMIT" VALUE="Refresh" style="width : 150px;">
			<INPUT TYPE="checkbox" NAME="test" ID="test" VALUE="1" <?php if ($_GET['test'] == '1') echo "CHECKED"; ?>> Test Connection
			</FORM>
			</center>
<!-- MASTER TABLE --></TD></TR></TABLE>
<P>
		<FONT SIZE="-3">&copy;2003-<?= date('Y'); ?> <A HREF="http://daevid.com" TARGET="_blank">Daevid Vincent</A> All Rights Reserved. <A HREF="http://daevid.com/examples/dhcp/dhcp_web.tgz">Download dhcp_web.tgz</A> (version: <?php echo "v".date("m.d.y",filemtime("./dhcp_web.tgz")); ?>) 
		</FONT>

<!-- Google Analytics - BEGIN -->
<script type="text/javascript">
	var gaJsHost = (("https:" == document.location.protocol) ? "https://ssl." : "http://www.");
	document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
</script>
<script type="text/javascript">
	var pageTracker = _gat._getTracker("UA-3501291-1");
	pageTracker._initData();
	pageTracker._trackPageview();
</script>
<!-- Google Analytics - END -->

</body>
</html>
